const getPostData = (action, args, payloadOutput) => {
    let data =  {
        iw_payload_output: payloadOutput || 'json',
        security_token: iw_js_data.iw_env.security_token,
        c: window.location.pathname,
        a: action,
        iw_sess_hint: getSessionHint(),
        where_was_i: window.location.pathname
    };

    if (args) {
        // merge args object with data.
        data = {...data, ...args};
    }

    return {
        i: JSON.stringify({
            r: 'Controller',
            i: data
        })
    }
}

// returns 'nodeworx' or 'siteworx' by identifying first param in url.
const getSessionHint = () => {
    let params = window.location.pathname.split('/').filter(param => param);
    return params[0]
}

const postRequest = (action, args) => $.post('/xhr.php', getPostData(action, args))

const getResponseData = (response) => {
    let res = JSON.parse(response);
    return res.d;
}

/**
 * IWorx response code is different from http response code.
 * All responses with http code 200 has internal response codes,
 * see class JSON_Reply
 */
const getIworxResponseCode = (response) => {
    let res = JSON.parse(response);
    return res.c;
}

const responseSuccessful = (response) => {
    let res = JSON.parse(response);
    return res.c === 201;
}

const getResponseText = (response) => {
    let res = JSON.parse(response);
    return res.t;
}

export const xhr = {
    postRequest,
    getResponseData,
    getResponseText,
    getIworxResponseCode,
    responseSuccessful
}